package jp.or.cute.sangokushi;

import java.util.Hashtable;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Currency;
import java.util.LinkedList;
import java.util.Random;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.commonshttp.CommonsHttpOAuthConsumer;
import oauth.signpost.exception.OAuthCommunicationException;
import oauth.signpost.exception.OAuthExpectationFailedException;
import oauth.signpost.exception.OAuthMessageSignerException;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import jp.or.cute.sangokushi.httpclient.BattleResultCommand;
import jp.or.cute.sangokushi.httpclient.HttpClient;
import jp.or.cute.sangokushi.httpclient.HttpCommand;
import jp.or.cute.sangokushi.httpclient.RoomInfoCommand;
import jp.or.cute.sangokushi.model.Player;
import jp.or.cute.sangokushi.twitter.TweetArrayAdapter;
import jp.or.cute.sangokushi.twitter.TweetItem;
import jp.or.cute.sangokushi.twitter.TwitterJSON;
import jp.or.cute.sangokushi.twitter.TwitterOAuth;
import jp.or.cute.sangokushi.twitter.TwitterOperator;
import jp.or.cute.sangokushi.view.ChatView;
import jp.or.cute.sangokushi.view.MapView;
import jp.or.cute.sangokushi.view.WholeMapView;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.util.Log;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

/**
 * 戦闘画面用アクティビティー
 * @author iST
 * @version 0.1
 * @since 2010/03/26
 */
public class Battle extends Activity{
	private WholeMapView mWholeMap;
    PopupWindow mPopupWindow;
    private MapView map;
    ChatView mChatview;
    //for Twitter
	private TweetArrayAdapter mTweetArrayAdapter;
	private LinkedList<TweetItem> mChatTweetLists = new LinkedList<TweetItem>();
	private ListView mTweetList;
	private EditText mTweetEditor;
	Handler mTweetEditorHandler;

    
	private Player mPlayer;
    private String mUserID;
    public String mUserName;
    private String mRoomID;
    private String mRoomName;
    
	/*
	 * 詳細マップから全体マップへのハンドラー
	 */
	private Handler mWholeMapHandler = new Handler(){
    	public void handleMessage(Message msg){
    		try{
	    		int[] xy = (int[]) msg.obj;
	    		mWholeMap.drawArea(xy[0],xy[1]);
    		}catch (Exception e) {
    			e.printStackTrace();
			}
    	}
	};
    /*
     * 仮にプレイヤーを生成している
     */
	private Player[] makePlayers() {
		Random rnd = new Random();
		rnd.setSeed(11);
		Player[] players = new Player[10];
		for (int i=0;i<players.length;i++) {
			int x = rnd.nextInt(45) % 45;
			int country = (x % 2);
			int y = rnd.nextInt(45) % 45;
			//Log.d("makePlayers","i="+Integer.toString(i)+"|x="+Integer.toString(x)+"|y="+Integer.toString(y));
			players[i] = new Player(this,Integer.toString(i+1)+" Force");
			players[i].setPoint(x, y);
			players[i].setCountry(country);
		}
		return players;
	}
	
	private Player[] makePlayers(String msg) {
		String[] pInfo = msg.split(">>");
		//Log.d("makePlayers","size="+Integer.toString(pInfo.length));
		Player[] players = new Player[pInfo.length-1];
		//Log.d("makePlayers","players size="+Integer.toString(players.length));
		for (int i=1,j=0;i<pInfo.length;i++,j++) {
			int top = 0;
			String[] pValue = pInfo[i].split(",");
			//Log.d("makePlayers","["+pValue[0]+"]["+pValue[1]+"]["+pValue[2]+"]["+pValue[3]+"]["+pValue[4]+"]");
			//Log.d("makePlayers","Call setInfo i="+Integer.toString(i)+"|j="+Integer.toString(j));
			players[j] = new Player(this,pValue[top+1]);
			int cell = Integer.parseInt(pValue[top+3]);
			int power = Integer.parseInt(pValue[top+4]);
			players[j].setInfo(power, 0, pValue[top+0], Integer.parseInt(pValue[top+2])-1, cell);
			if (pValue[top+1].equals(mUserName)) {
				mPlayer = players[j];
			}
		}
		return players;
	}
	
	
	public void onParam()
	{
	
	}

	public Player[] getPlayerInfo()
	{
		SangokushiPreferences pref = new SangokushiPreferences(this);
		BattleResultCommand command = new BattleResultCommand(HttpCommand.POST, pref.getSessionID(),mRoomID);
		HttpClient httpclient = HttpClient.getInstance();
		httpclient.setHttpCommand(command);
		String playerInfo = (String) httpclient.execute();
		Log.d("Battle","playerInfo="+playerInfo);
//		String playerInfo = map.getLobbyPlayers();
		Player[] players = makePlayers(playerInfo);
		return players;
	}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.battle);
		SangokushiPreferences pref = new SangokushiPreferences(this);
        
		mChatview = (ChatView) findViewById(R.id.ChatView);
        //userid,roomid
        Intent intent = getIntent();
        String msg = (String)intent.getSerializableExtra("String");
        Log.d("Battle","Intent msg=\"" + msg + "\"");
        String[] msgArr = msg.split(",");
        mUserID = msgArr[0];
        mRoomID = msgArr[1];
        mRoomName = msgArr[2];
        mUserName = msgArr[3];
		TextView mRoomNameView = (TextView) findViewById(R.id.TextView02);
		mRoomNameView.setText(mRoomName);

		// roomのターン情報を取得
		RoomInfoCommand command = new RoomInfoCommand(HttpCommand.POST, pref.getSessionID(), mRoomID);
		HttpClient httpclient = HttpClient.getInstance();
		httpclient.setHttpCommand(command);
		
		String result = (String) httpclient.execute();
		Log.d("getRoomInfo","rsult="+result);
    	String[] param = result.split(">>");
    	String[] value = param[1].split(",");
    	int maxTurn = Integer.valueOf(value[0]);
    	int currentTurn = Integer.valueOf(value[1]);
    	int diffTurn = maxTurn - currentTurn;
    	TextView currentTurnView = (TextView) findViewById(R.id.TextView03);
    	currentTurnView.setText(Integer.toString(currentTurn)+"日目");
    	TextView diffTurnView = (TextView) findViewById(R.id.TextView01);
    	diffTurnView.setText("残り"+Integer.toString(diffTurn)+"日");
    	
		mUserName = pref.getUserName();
        // = new Player(this,mUserName);

		map = (MapView) findViewById(R.id.MapView);
		map.mUserName = mUserName;
		Player[] players = getPlayerInfo();
		int[] CountryPower = new int[3];
		int[] unit = new int[3];
		String[] general = new String[3];
		mPlayer.setMySelf();

		for (int i=0;i<players.length;i++) {
			int c = players[i].getCountryID();
			CountryPower[c] += players[i].getPower();
			unit[c]++;
			if (players[i].getCommanderClass() == Player.GENERAL) {
				general[c] = players[i].getName();
			}
			if (players[i].getName().equals(mUserName)) {
				players[i].setMySelf();
//				player = players[i];
			}
		}
		Log.d("Battle","Power=["+Integer.toString(CountryPower[0])+"]["+Integer.toString(CountryPower[1])+"]["+Integer.toString(CountryPower[2])+"]");
		Log.d("Battle","Unit=["+Integer.toString(unit[0])+"]["+Integer.toString(unit[1])+"]["+Integer.toString(unit[2])+"]");
		
		int power1 = CountryPower[0];
		int power2 = CountryPower[1];
		int unit1 = unit[0];
		int unit2 = unit[1];
		String country1 = Player.getCountryName(0);
		String country2 = Player.getCountryName(1);
		String power1String = Integer.toString(power1);
		String power2String = Integer.toString(power2);
		String unit1String = Integer.toString(unit1);
		String unit2String = Integer.toString(unit2);
		String statusMsg = country1+"軍 総兵力 "+power1String+"名\n　　 総ユニット数 "+unit1String+"ユニット\n"+country2+"軍 総兵力 "+power2String+"名\n　　 総ユニット数 "+unit2String+"ユニット";
		TextView statusView = (TextView) findViewById(R.id.StatusView);
		statusView.setText(statusMsg);
		
		mWholeMap = (WholeMapView) findViewById(R.id.WholeMap);
		map.setWholeMapView(mWholeMap);
		mWholeMap.setPlayer(mPlayer);
		mWholeMap.setPlayers(players);
		map.setWholeMapViewHandler(mWholeMapHandler);
		map.setPlayer(mPlayer);
		map.setPlayers(players);
		map.setUserAndRoom(mUserID,mRoomID);
		map.setContent(this);

		mChatview.init(this, mRoomID, mPlayer.getCountryName());
        
//        initPopUp();
        mTweetList = mChatview.getTweetList();
        mTweetEditor =  mChatview.getTweetEditor();
        //mTweetList = (ListView) mChatview.findViewById(R.id.TweetListView);
//        mChatTweetLists.add(new TweetItem("AB1"));
//        mChatTweetLists.add(new TweetItem("AB2"));
//        mChatTweetLists.add(new TweetItem("AB3"));
//        mChatTweetLists.add(new TweetItem("AB4"));
        
        mTweetArrayAdapter = new TweetArrayAdapter(this, R.layout.tweetlist, mChatTweetLists);
		mTweetList.setAdapter(mTweetArrayAdapter);
		//mTweetList.setSelection(0);
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		Log.d("Battle","onDestory()");
		super.onDestroy();
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		Log.d("Battle","onPause()");
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		Log.d("Battle","onStop()");
		super.onResume();
	}
	
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		Log.d("Battle","onResume()");
		super.onResume();
	}

	public Handler getTwitterAuthenticateHandler(){
		return mAuthenticateHandler;
	}
	/*
	 * 認証処理のハンドラ
	 * TwitterCredentialRunnableからsendされる
	 */
    private Handler mAuthenticateHandler = new Handler(){
    	public void handleMessage(Message msg){
    		JSONObject json = (JSONObject) msg.obj;
    		if(json != null){
    			//認証OK
    			
    		}else{
    			//認証がとおらなければTwitter認証画面へ遷移
    			//startOAuth();
    			startTwitterAuth();
    		}
    	}
    };
    private void startTwitterAuth(){
    	try{
			Intent intent = new Intent(this, TwitterOAuth.class);
			//intent.setFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
			startActivityForResult(intent, Opening.RESULT_OAUTH);
    	}catch(Exception e){
    		e.printStackTrace();
		}
    }


	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		if(requestCode == Opening.RESULT_OAUTH){
			//認証用Activity（TwitterOAuth）からの戻り
			if(resultCode == RESULT_OK){
				//認証OK
				mChatview.loadTweets(mChatview.getChatTag());
			}else{
				//認証NG
			}
		}
	}
	

	@Override
	public void onWindowFocusChanged(boolean hasFocus) {
		super.onWindowFocusChanged(hasFocus);
		
		if(getCurrentFocus().equals(mTweetEditor)){
			mTweetEditorHandler = new Handler();
		    Message m = Message.obtain(mTweetEditorHandler, new Runnable() {
		        @Override
		        public void run() {
		          InputMethodManager manager = (InputMethodManager)getSystemService(Activity.INPUT_METHOD_SERVICE);
		          manager.showSoftInput(mTweetEditor, InputMethodManager.SHOW_IMPLICIT);
		        }
		      });
		    mTweetEditorHandler.sendMessage(m);
		}
	}
	/*============================================
	 * Twitter
	 * =========================================== */
	private String mHashTag;
	public String getHashTag(){
		return mHashTag;
	}
	/*
	 * Tweet取得
	 */
	public void loadTweets(String hashtag){
		mHashTag = hashtag;
		HashTagSelector hs = new HashTagSelector(TwitterOperator.SEARCH_TIMELINE_URL_STRING, hashtag);
		new GetHashTagTimelineTask().execute(hs);
	}
	/*
	 * Tweet送信
	 */
	public void sendTweet(String hashtag){
		mHashTag = hashtag;
		String postString = mTweetEditor.getText().toString();
		postString = "[" + mUserName + "] " + postString + " " + hashtag;
		new PostTask().execute(postString);
	}

	private class HashTagSelector extends Object {
		public String url;
		public Long since_id;
		public Long max_id;
		public Integer count;
		public Integer page;
		public Integer rpp = 10;
		public String q;
		
		public HashTagSelector(String u, String tag) {
			url = u;
			max_id = null;
			since_id = null;
			count = null;
			page = null;
			if(tag == null){
				q = TwitterOperator.DEFAULT_HASHTAG;
			}else{
				q = tag;
			}
		}
		
		@SuppressWarnings("unused")
		public HashTagSelector(String u, Long since, Long max, Integer cnt, Integer pg, String tag) {
			url = u;
			max_id = max;
			since_id = since;
			count = cnt;
			page = pg;
			if(tag == null){
				q = TwitterOperator.DEFAULT_HASHTAG;
			}else{
				q = tag;
			}
		}
	}	
	/*
	 * 特定のハッシュタグをもつ発言を取得
	 */
	private class GetHashTagTimelineTask extends AsyncTask<HashTagSelector, Void, JSONArray> {

		DefaultHttpClient mClient;
		//OAuth
		private OAuthConsumer mConsumer;
		
		@Override
		protected void onPreExecute() {
			mClient = new DefaultHttpClient();
			//OAuthコンシューマー
			mConsumer = new CommonsHttpOAuthConsumer(
					TwitterOperator.TWITTER_CONSUMER_KEY, 
					TwitterOperator.TWITTER_CONSUMER_SECRET);     

		}

		@Override
		protected JSONArray doInBackground(HashTagSelector... params) {
			JSONArray array = null;
			try {
				for(int i = 0; i < params.length; ++i) {
					Uri sUri = Uri.parse(params[i].url);
					Uri.Builder builder = sUri.buildUpon();
					if(params[i].since_id != null) {
						builder.appendQueryParameter("since_id", String.valueOf(params[i].since_id));
					} else if (params[i].max_id != null) { // these are mutually exclusive
						builder.appendQueryParameter("max_id", String.valueOf(params[i].max_id));
					}
					if(params[i].count != null) {
						builder.appendQueryParameter("count", String.valueOf((params[i].count > 200) ? 200 : params[i].count));
					}
					if(params[i].rpp != null) {
						builder.appendQueryParameter("rpp", String.valueOf(params[i].rpp));
					}
					if(params[i].page != null) {
						builder.appendQueryParameter("page", String.valueOf(params[i].page));
					}
					if(params[i].q != null) {
						builder.appendQueryParameter("q", String.valueOf(params[i].q));
					}
					HttpGet get = new HttpGet(builder.build().toString());
					mConsumer.sign(get);
					String response = mClient.execute(get, new BasicResponseHandler());
					if(!response.startsWith("[")){
						response = "[" + response + "]";
					}
					array = new JSONArray(response);
				}
			} catch (JSONException e) {
				e.printStackTrace();
			} catch (OAuthMessageSignerException e) {
				e.printStackTrace();
			} catch (OAuthExpectationFailedException e) {
				e.printStackTrace();
			} catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (OAuthCommunicationException e) {
				e.printStackTrace();
			}
			return array;
		}

		// This is in the UI thread, so we can mess with the UI
		protected void onPostExecute(JSONArray array) {
			mClient.getConnectionManager().shutdown();
			JSONArray realArray = null;
			if(array != null) {
				try {
					if(array.length() == 1){
						JSONObject checkStatus = array.getJSONObject(0);
						if(checkStatus.has("query") && checkStatus.has("results")){
							//検索結果
							realArray = checkStatus.getJSONArray("results");
						}
					}else{
						realArray = array;
					}
					mChatTweetLists.clear();
					for(int i = 0; i < realArray.length(); ++i) {
						JSONObject status = realArray.getJSONObject(i);
						TwitterJSON json = new TwitterJSON(Battle.this);
						TweetItem item = new TweetItem(Battle.this, json, status);
						mChatTweetLists.add(item);
					}
					mTweetArrayAdapter.notifyDataSetChanged();
				} catch (JSONException e) {
					e.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else {
			}
		}
	}
	
	/*
	 * Tweetの送信
	 */
	private class PostTask extends AsyncTask<String, Void, JSONObject> {
 
		ProgressDialog postDialog;
		DefaultHttpClient mClient;
		//OAuth
		private OAuthConsumer mConsumer;

		@Override
		protected void onPreExecute() {
			if(Battle.this.isFinishing()){
				this.cancel(true);
				return;
			}
			SangokushiPreferences pref = new SangokushiPreferences(Battle.this);
			
			mClient = new DefaultHttpClient();
			//OAuthコンシューマー
			mConsumer = new CommonsHttpOAuthConsumer(
					TwitterOperator.TWITTER_CONSUMER_KEY, 
					TwitterOperator.TWITTER_CONSUMER_SECRET);   
			TwitterOperator operator = new TwitterOperator(Battle.this);
			mConsumer.setTokenWithSecret(operator.getTwitterToken(), operator.getTwitterSecret());
			postDialog = ProgressDialog.show(Battle.this, 
					getText(R.string.tweet_progress_title), 
					getText(R.string.tweet_progress_text), 
					true,
					false);
		}
 
		@Override
		protected JSONObject doInBackground(String... params) {
 
			JSONObject jso = null;
			try {
				HttpPost post = new HttpPost(TwitterOperator.TWITTER_UPDATE_URL);
				LinkedList<BasicNameValuePair> out = new LinkedList<BasicNameValuePair>();
				out.add(new BasicNameValuePair("status", params[0]));
				post.setEntity(new UrlEncodedFormEntity(out, HTTP.UTF_8));
				post.setParams(getParams());
				// sign the request to authenticate
				mConsumer.sign(post);
				String response = mClient.execute(post, new BasicResponseHandler());
				jso = new JSONObject(response);
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			} catch (OAuthMessageSignerException e) {
				e.printStackTrace();
			} catch (OAuthExpectationFailedException e) {
				e.printStackTrace();
			} catch (OAuthCommunicationException e) {
				e.printStackTrace();
			} catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (JSONException e) {
				e.printStackTrace();
			} finally {
 
			}
			return jso;
		}
 
		// This is in the UI thread, so we can mess with the UI
		protected void onPostExecute(JSONObject jso) {
			mClient.getConnectionManager().shutdown();
			postDialog.dismiss();
			if(jso != null) { // authorization succeeded, the json object contains the user information
				mTweetEditor.setText("");
				//mLast.setText(json.getCurrentTweet(jso));
				loadTweets(mHashTag);
			} else {
				//mLast.setText(getText(R.string.tweet_error));
			}
		}
	}
	public HttpParams getParams() {
		HttpParams params = new BasicHttpParams();
		HttpProtocolParams.setUseExpectContinue(params, false);
		return params;
	}	

	
}
