package jp.or.cute.sangokushi;

/**
 * ロビー画面
 * @author akifumi3
 * @author takki
 * @version 0.1.2
 * @since 2010/04/28
 * @change 2010/05/02
 * @change 2010/05/11
 * オープニング画面が呼び出される
 * ロビーを選択すると戦闘画面に移行する
 */

import jp.or.cute.sangokushi.httpclient.EnteringLobbyCommand;
import jp.or.cute.sangokushi.httpclient.BattleResultCommand;
import jp.or.cute.sangokushi.httpclient.HttpClient;
import jp.or.cute.sangokushi.httpclient.HttpCommand;
import jp.or.cute.sangokushi.httpclient.LeavingLobbyCommand;
import jp.or.cute.sangokushi.httpclient.LobbyInfoCommand;
import jp.or.cute.sangokushi.httpclient.UserStatusCommand;

import android.app.Activity;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Message;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;
import android.view.View;
import android.widget.*;

public class Lobby extends Activity {
	public static final int RESULT_OAUTH = 1001;
	private Activity me;
	private String user_id;
	private String room_id;
	private String room_name;
	private String[] battleStatusList;
	private SangokushiPreferences mPref;

    private TextView userName;
    private TextView userWin;
    private TextView userLose;
    private ImageView map;
    
    public battle_Status[] makeBattleStatus(String result) {
    	int max_data = 5; // param.length-1;
    	battleStatusList = new String[max_data];
    	battle_Status[] bs = new battle_Status[max_data];
    	if(result == null){
    		return bs;
    	}
    	String[] param = result.split(">>");
   	
    	for(int j=1,i=0;j<6;j++,i++){
    		String[] value = param[j].split(",");
    		bs[i] = new battle_Status();
    		bs[i].setlocation(value[1]);
    		bs[i].setRoomid(Integer.parseInt(value[0]));
    		if (value[2] == "0") {
    			bs[i].setOngoing(false);
    		} else if (value[2] == "2"){
    			bs[i].setOngoing(true);
    		} else {
       			bs[i].setOngoing(false);
       		}
    		String location = value[1] + "之戦";
    		bs[i].setlocation(location);
    		
    		/*
    		 * RoomID毎の戦況を取得し格納
    		 */
    		String[] temp = getBattle(value[0],value[3],value[4]).split(",");
    		bs[i].setGeneralAndPeople(temp[0],Integer.parseInt(temp[1]),Integer.parseInt(temp[2]),temp[3],Integer.parseInt(temp[4]),Integer.parseInt(temp[5]));
    		   		
    		//対戦国  魏 VS 蜀 などの情報を格納
    		bs[i].setAttackCountry(value[3]);
    		bs[i].setDefenceCountry(value[4]);
    		
    		//経過日数
    		bs[i].setPastDay(value[7]);
    		
    	}
    	
    	return bs;
	}
    
    public String getBattle(String roomid,String attack,String defence){
    	/*
    	 * 引数から攻撃国/守備国を判断します
    	 * 引数；room_id ,攻撃国ID(1-3), 守備国ID(1-3)
    	 */
		int attackPeoples = 0;	//攻撃側参加人数(ユーザー数)
		int attackSoldiers = 0;	//攻撃側総兵力
		int defencePeoples = 0;	//防御側参加人数(ユーザー数)
		int defenceSoldiers = 0;//攻撃側総兵力
		
		String attackGeneral = "";
		String defenceGeneral = "";

    	BattleResultCommand brc = new BattleResultCommand(HttpCommand.POST,mPref.getSessionID());
        brc.setParam("roomid",roomid);
        HttpClient brc_httpClient = HttpClient.getInstance();
        brc_httpClient.setHttpCommand(brc);
		String res = (String) brc_httpClient.execute();
		String[] result_temp = res.split(">>");
		
		for(int i=1;i<result_temp.length;i++){
			String[] temp = result_temp[i].split(",");
			//B,AI 2 攻撃,2,29,10>>
			//B,AI 1 守備,1,3571,9>>
			if(attack.equals(temp[2])){
				//攻撃国
				attackSoldiers += Integer.parseInt(temp[4]);
				attackPeoples++;
				
				if(temp[0].equals("s")){
					attackGeneral = temp[1];
				}
			}else if(defence.equals(temp[2])){
				//守備国
				defenceSoldiers += Integer.parseInt(temp[4]);
				defencePeoples++;
				if(temp[0].equals("s")){
					defenceGeneral = temp[1];
				}			
			}
		}
		// '"攻撃国 総大将", "攻撃国 参加人数","攻撃国 兵力","守備国 総大将","守備国 参加人数","守備国 兵力"'の形式で戻す
		return attackGeneral + "," + String.valueOf(attackPeoples) + "," + String.valueOf(attackSoldiers) +","+ defenceGeneral +","+String.valueOf(defencePeoples)+"," + String.valueOf(defenceSoldiers);
    	
    }

	@Override
	protected void onResume() {

        userName = (TextView)findViewById(R.id.TextView01);
        userWin = (TextView)findViewById(R.id.TextView04);
        userLose = (TextView)findViewById(R.id.TextView06);
        map = (ImageView) findViewById(R.id.map);
        final ListView list1 = (ListView) findViewById(R.id.ListView01);
        me = this;
       
        /*
         * ロビー情報取得・作成
         */
        //通信コマンドにsessionIDを追加 by iST
		mPref = new SangokushiPreferences(this);
		LobbyInfoCommand command = new LobbyInfoCommand(HttpCommand.POST, mPref.getSessionID());
		HttpClient httpclient = HttpClient.getInstance();
		httpclient.setHttpCommand(command);
		String result = (String) httpclient.execute();
		Log.d("Lobby","result="+result);
        battle_Status[] bs = makeBattleStatus(result);
        
        for(int i =0;i<bs.length;i++){
        	if(bs[i] == null){
        		continue;
        	}
    		battleStatusList[i] = bs[i].getlocation();
    		//if(bs[i].isOngoing()){
    		if(bs[i].pastDay > 0){
        		battleStatusList[i] += "   "+ bs[i].getPastDay()+"日経過";
        	}else{
        		battleStatusList[i] += "   開戦前";
        	}
        }

        /*
         * 戦リスト作成処理(ListView)
         */
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.list, battleStatusList);
        list1.setAdapter(adapter);
        list1.setSelection(0);
        list1.setOnItemClickListener(new MyClickAdapter(bs,bs.length));

        /*
         * UserStatus(画面下側)作成処理
         */
        //Preferenceからユーザ名を取得し設定
        userName.setText(mPref.getUserName());
        
        //戦況(個人成績)をサーバー問い合わせ
		UserStatusCommand mUserStatusCommand = new UserStatusCommand(HttpCommand.POST, mPref.getSessionID());
		mUserStatusCommand.setParam("userid",mPref.getUserID());
		HttpClient ust_httpClient = HttpClient.getInstance();
		ust_httpClient.setHttpCommand(mUserStatusCommand);
		String ust_result = (String) ust_httpClient.execute();
		makeUserStatus(ust_result);
		
		//中央の所属国画像を取得・表示
	    Resources r = getResources();
	    Bitmap bmp_map;
	    bmp_map = BitmapFactory.decodeResource(r, R.drawable.gi_bg);
	    
	    switch(Integer.parseInt(mPref.getCountryID())){
	    case 1:
		    break;
	    case 2:
		    bmp_map = BitmapFactory.decodeResource(r, R.drawable.go_bg);
		    break;
	    case 3:
		    bmp_map = BitmapFactory.decodeResource(r, R.drawable.syoku_bg);
		    break;
		default:
			break;
			
	    }
		map.setImageBitmap(bmp_map);
		
        
		super.onResume();		
	}
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lobby);

    }

    private void makeUserStatus(String result){
    	String[] ust = result.split(">>");
    	String[] win_lose = ust[1].split(",");
    	
    	if(win_lose.length == 2){
    		//ERRORじゃなかった場合
	    	userWin.setText(win_lose[0]+"回");
	    	userLose.setText(win_lose[1]+"回");
    	}else{
    		//lengthが2以外の場合はエラーコードと判断
    		String error_text = "戦歴の取得に失敗しました\n(error:U01005 >>"+ust[1]+")";
        	userWin.setText("取得NG");
        	userLose.setText("取得NG");
        	
    		Log.d("Lobby","U01005 result is "+ust[1]);
	    	
    		//失敗メッセージをToast表示
			Toast.makeText(this, error_text, Toast.LENGTH_LONG).show();
    	}
    }


    // イベントクラス
    class MyClickAdapter implements OnItemClickListener {
    	//fix magic number. akifumi3
    	//battle_Status[] bs_copy = new battle_Status[5];//TODO also magic number too.
    	battle_Status[] bs_copy;

    	public MyClickAdapter(battle_Status _bs[],int num){
    		//Magic number修正により引数変更と配列初期化をここへ移動
    		bs_copy = new battle_Status[num];
    		bs_copy = _bs;
    	}

        /*
         * Battle遷移 @Takki
         */
        private void startBattle(){
        	try{
        		Log.d("Debug","Intent call");
        		//SharedPreferencesからuserIDを取得 by iST
        		user_id = mPref.getUserID();
        		
        		leaveRoom();
        		if(enterRoom()) {
	    			Intent intent = new Intent(me, Battle.class);
	    			String msg = user_id + "," + room_id +"," + room_name+","+mPref.getUserName();
	    			intent.putExtra("String", msg);
	    			startActivityForResult(intent, RESULT_OAUTH);
        		}
        	}catch(Exception e){
        		e.printStackTrace();
    		}
        }
    	
        /*
         * 退室処理 @masa
         */
        private void leaveRoom(){
        	LeavingLobbyCommand command = new LeavingLobbyCommand(HttpCommand.POST, room_id, user_id, mPref.getSessionID());

			Log.d("Debug", "leave_room");
			Log.d("room_id", room_id);
			Log.d("user_id", user_id);
			Log.d("s_id", mPref.getSessionID());

        	HttpClient httpclient = HttpClient.getInstance();
        	httpclient.setHttpCommand(command);
        	String result = (String)httpclient.execute();
			Log.d("leave_room_result", result);
        }
        
        
        /*
         * 入室処理 @masa
         */
        private boolean enterRoom(){
			EnteringLobbyCommand command = new EnteringLobbyCommand(HttpCommand.POST, room_id, user_id, mPref.getSessionID());

			Log.d("Debug", "leave_room");
			Log.d("room_id", room_id);
			Log.d("user_id", user_id);
			Log.d("s_id", mPref.getSessionID());

        	HttpClient httpclient = HttpClient.getInstance();
    		httpclient.setHttpCommand(command);
    		String result = (String) httpclient.execute();
			Log.d("enter_room_result", result);
    		String[] resArray = result.split(">>");

    		String[] dataArray1 = resArray[0].split(",");

/*
    		String[] dataArray2 = resArray[1].split(",");
    		for(int i = 0; i < dataArray2.length; i++) {
    			Log.d("enter_room_res2", i + "=" + dataArray2[i]);
    		}
*/    		
    		
    		if(dataArray1[1].equals("0")) {
    			return true;
    		} else {
    			Log.d("enter_room_res", dataArray1[1]);
    			Toast.makeText(me, "参戦に失敗しました。", Toast.LENGTH_LONG).show();
    			return false;
    		}
        }
        
        @Override
        public void onItemClick(AdapterView<?> adapter,
                View view, int position, long id) {
            AlertDialog.Builder bldr = new AlertDialog.Builder(me);

            bldr.setTitle("戦況");//TODO values/string/hoge に直す

            String dialog_message = bs_copy[position].getAll_jp();
            bldr.setMessage(dialog_message);
            room_id = Integer.toString(bs_copy[position].getRoomid());
            room_name= bs_copy[position].getRoomName();

            DialogInterface.OnClickListener listner = new DialogInterface.OnClickListener(){
            	@Override
            	public void onClick(DialogInterface dialog, int which) {
            		Log.d("Button",Integer.toString(which));
            		setResult(RESULT_OK);
                }
            };
            //TODO String.xmlを参照する予定
            bldr.setPositiveButton("参戦する",new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface dialog, int which) {
					Log.d("Button push","compete");
					startBattle();
				}
			});
            bldr.setNegativeButton(getString(R.string.cancel), listner);
            bldr.create();
            bldr.show();
        }
        

    }

    public class battle_Status {
    	private int roomid;
        private String location;	//赤壁乃戦 など
        private boolean ongoing;	//true = 対峙中, false = 開戦前
    	private int pastDay = 0;		//経過日数
    	//日数でターンを表すので時間は不要に・・・
    	//private int fromHour;		//経過時間
    	
    	private String attackCountry; 		//攻撃国名 ("魏" or "呉" ..)
    	private String attackGeneral;		//総大将 ("張遼" ..)
    	private int attackPeoples;			//攻撃側参加人数(ユーザー数)
    	private int attackSoldiers;			//攻撃側 総兵力
    	
    	private String defenceCountry; 		//防御国名 ("蜀" or "魏" ..)
    	private String defenceGeneral;		//総大将 ("張遼" ..)
    	private int defencePeoples;			//防御側参加人数(ユーザー数)
    	private int defenceSoldiers;		//防御側 総兵力

    	public void setAttackCountry(String countryID){
    		switch(Integer.parseInt(countryID)){
    		case 1:
    			attackCountry = "魏";
    			break;
    		case 2:
    			attackCountry = "呉";
    			break;
    		case 3:
    			attackCountry = "蜀";
    			break;
    		default:
    			break;
    		}
    		
    	}
    	public void setDefenceCountry(String countryID){
    		switch(Integer.parseInt(countryID)){
    		case 1:
    			defenceCountry = "魏";
    			break;
    		case 2:
    			defenceCountry = "呉";
    			break;
    		case 3:
    			defenceCountry = "蜀";
    			break;
			default:
				break;
    		}
    	}
    	
    	public void setPastDay(String pastday){
    		pastDay = Integer.parseInt(pastday);
    	}
    	
    	public int getPastDay(){
    		return pastDay;
    	}
    	
        public String getlocation() {
            return location;
        }

        public int getRoomid() {
        	return this.roomid;
        }
        

        public String getRoomName() {
        	return this.location;
        }

        public void setRoomid(int id) {
            this.roomid = id;
        }

        public void setlocation(String location) {
            this.location = location;
        }

        public void setOngoing(boolean going)
        {
        	this.ongoing = going;
        }
        
        public void setGeneralAndPeople(String attackGeneral,int attackPeoples, int attackSoldiers,String defenceGeneral,int defencePeoples,int defenceSoldiers){
        	this.attackGeneral = attackGeneral;
        	this.attackPeoples = attackPeoples;
        	this.attackSoldiers = attackSoldiers;
        	this.defenceGeneral = defenceGeneral;
        	this.defencePeoples = defencePeoples;
        	this.defenceSoldiers = defenceSoldiers;
        }
        
        public boolean isOngoing(){
        	if(ongoing){
        		return true;
        	}else{
        		return false;
        	}
        }

    	public String getAll_jp(){
    		String ret= "";
    		if(pastDay == 0){
    			ret =  location+"   開戦前\n\n"+attackCountry+" 軍   総大将 "+attackGeneral +"\n  参加人数 "+attackPeoples+"人   兵力 "+attackSoldiers+"\n                   VS\n"+defenceCountry+" 軍   総大将 "+defenceGeneral +"\n  参加人数 "+defencePeoples+"人   兵力 "+defenceSoldiers+"\n";
    		}else{
    			ret =  location+"   "+pastDay+"日\n\n"+attackCountry+" 軍   総大将 "+attackGeneral +"\n  参加人数 "+attackPeoples+"人   兵力 "+attackSoldiers+"\n                   VS\n"+defenceCountry+" 軍   総大将 "+defenceGeneral +"\n  参加人数 "+defencePeoples+"人   兵力 "+defenceSoldiers+"\n";
    		}
    		return ret;
    	}
    }

}