package jp.or.cute.sangokushi;

import android.R.bool;
import android.content.Context;
import android.content.SharedPreferences;

public class SangokushiPreferences {
	public static final String PREFS = "OpenSangokushiPrefs";
	public static final String SESSION_ID = "SessionID";
	public static final String USER_NAME = "UserName";
	public static final String USER_ID = "UserID";
	public static final String COUNTRY_ID = "CountryID";

    public static final int RESULT_OAUTH = 1001;
    public static final int RESULT_INIT = 1002;
    public static final int RESULT_LOBBY = 1003;

    private SharedPreferences mSettings;
	private SharedPreferences.Editor mEditor; 
	private Context mContext;
	
	public SangokushiPreferences(Context context) {
		mContext = context;
		mSettings = mContext.getSharedPreferences(PREFS, Context.MODE_PRIVATE);
	}
	
	/*
	 * SessionIDの受け渡し
	 */
	public String getSessionID(){
		return getStringPrefValue(SESSION_ID);
	}
	public void setSessionID(String id){
		setStringPrefValue(SESSION_ID, id);
	}
	
	/*
	 * UserIDの受け渡し
	 */
	public String getUserID(){
		return getStringPrefValue(USER_ID);
	}
	public void setUserID(String id){
		setStringPrefValue(USER_ID, id);
	}

	/*
	 * UserNameの受け渡し
	 */
	public String getUserName(){
		return getStringPrefValue(USER_NAME);
	}
	public void setUserName(String name){
		setStringPrefValue(USER_NAME, name);
	}

	/*
	 * 所属国IDの受け渡し
	 */
	public String getCountryID(){
		return getStringPrefValue(COUNTRY_ID);
	}
	public void setCountryID(String id){
		setStringPrefValue(COUNTRY_ID, id);
	}

	private String getStringPrefValue(String Key){
		String value = null;
		if(mSettings.contains(Key)) {
			value = mSettings.getString(Key, null);
		}
		return value;
	}
	private boolean setStringPrefValue(String key, String value){
		mEditor = mSettings.edit();
		mEditor.putString(key, value);
		return mEditor.commit();
	}
	
	/*
	 * 保存データの削除
	 */
	public boolean removeValue(String key){
		mEditor = mSettings.edit();
		mEditor.remove(key);
		return mEditor.commit();
	}
}
