package jp.or.cute.sangokushi.httpclient;

import java.io.IOException;
import java.util.ArrayList;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpResponseException;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeader;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.util.EntityUtils;

public class HttpClient {
	private static HttpClient instance = new HttpClient();
	
	//protected final static String BASE_URL = "http://210.196.147.49/";
	protected final static String BASE_URL = "http://210.196.147.48/";
	protected final static String BASE_PATH = "index.php";
	protected final static String AUTH_PATH = "authenticate/auth";
	
	//==== コマンド =====
	public final static String PARAMS_COMMAND = "data";
	public final static String PARAMS_SESSION_ID = "sid";
	//ユーザー認証（新規）コマンド
	public final static String COMMAND_USERAUTH_NEW = "U01001";
	//ユーザー認証（確認）コマンド
	public final static String COMMAND_USERAUTH_CHECK = "U01002";
	//所属国設定コマンド
	public final static String COMMAND_SET_COUNTRY_STATE = "C01001";
	//所属国情報取得コマンド
	public final static String COMMAND_GET_COUNTRY_STATE = "C01002";
	//ユーザー初期パラメータ取得コマンド
	public final static String COMMAND_GET_USER_PARAMS = "U01003";
	//ユーザー初期位置設定コマンド
	public final static String COMMAND_SET_USER_POSITION = "U01004";
	//ユーザーステータス取得コマンド
	public final static String COMMAND_GET_USER_STATUS = "U01005";
	//AI武将パラメータ取得コマンド
	public final static String COMMAND_GET_AI_PARAMS = "A01001";
	//ルーム情報取得コマンド
	public final static String COMMAND_GET_LOBBY_INFO = "R01001";
	//ルームステータス取得コマンド
	public final static String COMMAND_GET_LOBBY_STATUS = "R01002";
	// ルームのターン情報取得コマンド
	public final static String COMMAND_GET_LOBBY_TURN = "R01005";
	//ルーム入室コマンド
	public final static String PARAMS_LOBBY_ID = "roomid";
	public final static String PARAMS_PLAYER_ID = "userid";
	public final static String COMMAND_EXEC_LOBBY_IN = "R01003";
	//ルーム退室コマンド
	public final static String COMMAND_EXEC_LOBBY_OUT = "R01004";
	//マップ情報取得コマンド
	public final static String COMMAND_GET_MAP_INFO = "M01001";
	//戦闘情報送信コマンド
	public final static String COMMAND_SET_BATTLE = "B01001";
	public final static String COMMAND_LOBBYID ="roomid";
	public final static String COMMAND_PLAYERID ="userid";
	public final static String PARAMS_MOVEMAPCHIPNO="movemapchipno";
	public final static String PARAMS_BATTLEMAPCHIPNO="battlemapchipno";
	//戦闘結果取得コマンド
	public final static String COMMAND_GET_BATTLE = "B01002";

	private HttpCommand mHttpCommand;
	public void setHttpCommand(HttpCommand command){
		mHttpCommand = command;
	}
	public HttpCommand getHttpCommand(){
		return mHttpCommand;
	}
	
	private DefaultHttpClient mHttpclient;
	public DefaultHttpClient getHttpclient() {
		return mHttpclient;
	}

	public void setHttpclient(DefaultHttpClient httpclient) {
		mHttpclient = httpclient;
	}

	private HttpResponse mResponse;
	public HttpResponse getResponse() {
		return mResponse;
	}

	public void setResponse(HttpResponse response) {
		mResponse = response;
	}

	private String mSessionID;
	
	private HttpClient() {
		this.init();
	}
	
	public static HttpClient getInstance(){
		return instance;
	}
	
	private void init(){
    	mHttpclient = new DefaultHttpClient();
    	mHttpclient.getParams().setParameter("http.useragent", "android-sangokushi");
    	ArrayList<Header> params = new ArrayList<Header>();
    	params.add(new BasicHeader("Accept-Encoding", "gzip, deflate"));
    	mHttpclient.getParams().setParameter("http.default-headers", params);
    	//417エラー対策・・・ハマリ
    	mHttpclient.getParams().setParameter(CoreProtocolPNames.USE_EXPECT_CONTINUE, false);
    	
	}
	
	public Object execute(){
		String responseString = null;
		
		if(mHttpCommand != null){
			HttpPost method = mHttpCommand.execute(mSessionID);
			
            try {
            	this.setResponse(this.getHttpclient().execute(method));
                int statuscode = this.getResponse().getStatusLine().getStatusCode();
          			
                //リクエストが成功 200 OK and 201 CREATED
                if (statuscode == HttpStatus.SC_OK | statuscode == HttpStatus.SC_CREATED){
                	responseString = EntityUtils.toString(this.getResponse().getEntity(),"UTF-8");
                } else {
                    throw new HttpResponseException(statuscode, "Response code is " + Integer.toString(statuscode));
                }
            }catch (RuntimeException e) {
            	method.abort();
                //throw new RuntimeException(e);
            } catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}            	
        	
			
		}
		return responseString;
	}
}
