package jp.or.cute.sangokushi.httpclient;

import java.util.ArrayList;
import java.util.List;

import jp.or.cute.sangokushi.SangokushiPreferences;

import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;

import android.util.Log;

/*
 * HTTP通信処理　基底クラス
 * @author iST
 * @version 0.1
 * @since 2010/05/04
*/
public class HttpCommand {
	
	private String mPath;
	protected void setPath(String path){
		mPath = path;
	}

	private List<NameValuePair> mNameValuePair;
	public List<NameValuePair> getNameValuePair() {
		return mNameValuePair;
	}

	public void setNameValuePair(List<NameValuePair> nameValuePair) {
		mNameValuePair = nameValuePair;
	}
	
	public static final String POST = "post";
	public static final String GET = "get";
	private String mMethod;
	private String mQuery;
	
	private String mSessionID;

	public void setParam(String key, String value){
		if(mMethod == POST){
			if(mNameValuePair == null){
				mNameValuePair = new ArrayList<NameValuePair>();
			}
			mNameValuePair.add(new BasicNameValuePair(key, value));
		}else{
			if(mQuery != ""){
				mQuery += "&";
			}
			mQuery += key + "=" + value;
		}
	}

	/*
	 * コンストラクタ
	 */
	public HttpCommand(String method, String sessionID) {
		mMethod = method;
		
		if(sessionID != null){
			mSessionID = sessionID;
			setParam("sessionid", sessionID);
		}
	}

	public HttpPost execute(String sessionID){
		this.setParam(HttpClient.PARAMS_SESSION_ID,sessionID);

		HttpPost method = null;
        try {
        	method = new HttpPost(HttpClient.BASE_URL + mPath);
        	method.addHeader("Content-Type", "application/x-www-form-urlencoded");
        	Log.d("execute","value="+this.getNameValuePair().toString());
        	method.setEntity(new UrlEncodedFormEntity(this.getNameValuePair(), HTTP.UTF_8));
        	return method;
        } catch (Exception e) {
        	e.printStackTrace();
        }  
		return method;
	}
	
}
