package jp.or.cute.sangokushi.httpclient;
import android.os.Handler;
import android.os.Message;

public class ResponceHandler extends Handler{
	//==== サーバーエラーコード =====
	public final static String ERROR_CODE_DEFAULT = "01000";
	//ユーザー名の重複
	public final static String ERROR_CODE_INIT_DUPLICATION_USERNAME = "02000";
	//ユーザー登録時エラー
	public final static String ERROR_CODE_INIT_NOT_ENTRY = "03000";
	//ユーザー登録時エラー
	public final static String ERROR_CODE_INIT_NOT_ENTRY_OTHER = "04000";
	
	//==== レスポンスセパレータ =====
	public final static String RESPONCE_SEPARATOR = ">>";
	public final static String RESPONCE_PARTS_SEPARATOR = ",";

	private String mErrorCode;
	public String getErrorCode() {
		return mErrorCode;
	}
	public void setErrorCode(String errorCode) {
		mErrorCode = errorCode;
	}

	private boolean mErrorFlag = true;
	private String mRequestCode;
	
	private String mResponce;
	public String getResponce() {
		return mResponce;
	}
	public void setResponce(String responce) {
		mResponce = responce;
	}

	private String[] mResponceArray;

	public String[] getResponceArray() {
		return mResponceArray;
	}
	public void setResponceArray(String[] responceArray) {
		mResponceArray = responceArray;
	}
	@Override
	public void handleMessage(Message msg) {
		super.handleMessage(msg);
		mResponce = (String) msg.obj;
		if(mResponce != null && mResponce instanceof String){
			mResponceArray = mResponce.split(RESPONCE_SEPARATOR);
		}
		handleHeader();
	}
	private void handleHeader(){
		if(mResponceArray != null && mResponceArray.length > 0){
			String[] headers = mResponceArray[0].split(",");
			if(headers != null && headers.length > 1){
				mRequestCode = headers[0];
				if(headers[1].equals("1")){
					mErrorFlag = true;
					/**
					 *サーバーレスポンスの形式が変更による修正
					 *akifumi3 2010.05.12 
					 */
					//mErrorCode = headers[2]; 
					mErrorCode = mResponceArray[1];
				}else{
					mErrorFlag = false;
				}
			}
		}
	}
	public boolean isError(){
		return mErrorFlag;
	}
	/*
	 * レスポンスの">>"で区切られた内容に対して、”,”で分割して返却
	 * といっても単にsplitするだけ
	 */
	public static String[] splitResponceParts(String part){
		return part.split(RESPONCE_PARTS_SEPARATOR);
	}
}
