package jp.or.cute.sangokushi.twitter;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;


public class TweetArrayAdapter extends ArrayAdapter<TweetItem> {
	LayoutInflater mInflater;
	List<TweetItem> mItems;
	int mViewResourceId;
	
	public TweetArrayAdapter(Context context, int resource,
			int textViewResourceId, TweetItem[] objects) {
		super(context, resource, textViewResourceId, objects);
        mInflater = LayoutInflater.from(context);
        mViewResourceId = resource;
	}
	public TweetArrayAdapter(Context context, int resource,
			int textViewResourceId) {
		super(context, resource, textViewResourceId);
        mInflater = LayoutInflater.from(context);
        mViewResourceId = resource;
	}
	public TweetArrayAdapter(Context context, int textViewResourceId,
			List<TweetItem> objects) {
		super(context, textViewResourceId, objects);
        mInflater = LayoutInflater.from(context);
        mItems = objects;
        mViewResourceId = textViewResourceId;
	}
	public TweetArrayAdapter(Context context, int textViewResourceId,
			TweetItem[] objects) {
		super(context, textViewResourceId, objects);
        mInflater = LayoutInflater.from(context);
        for (int i=1,j=0;i<objects.length;i++,j++) {
        	mItems.add(objects[i]);
        }
        mViewResourceId = textViewResourceId;
	}
	public TweetArrayAdapter(Context context, int textViewResourceId) {
		super(context, textViewResourceId);
        mInflater = LayoutInflater.from(context);
        mViewResourceId = textViewResourceId;
	}
	public TweetArrayAdapter(Context context, int resource, int textViewResourceId, List<TweetItem> objects) {
		super(context, resource, textViewResourceId, objects);
        mInflater = LayoutInflater.from(context);
        mItems = objects;
        mViewResourceId = resource;
	}
	@Override
	public View getView(int pos, View view, ViewGroup parent) {
		String t;
		ViewHolder holder;
		if(view == null) {
			view = mInflater.inflate(mViewResourceId, null);
			view.setPadding(
					view.getPaddingLeft(),
					view.getPaddingTop()+5,
					view.getPaddingRight(),
					view.getPaddingBottom()+2);
			holder = new ViewHolder();
			//holder.text1 = (TextView) view.findViewWithTag("tweet_name");
			holder.text2 = (TextView) view.findViewWithTag("tweet_tweet");
			view.setTag(holder);
		} else {
			holder = (ViewHolder) view.getTag();
		}
		TweetItem item = this.getItem(pos);
		//holder.text1.setText(item.getGameUserName() + ">>");
		holder.text2.setText(item.getTweet());
		return view;
	}

	public String getTweet(int pos){
		TweetItem item = this.getItem(pos);
		return item.getText();
	}
    private class ViewHolder {
        TextView text1;
        TextView text2;
        
    }

}
