package jp.or.cute.sangokushi.twitter;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import jp.or.cute.sangokushi.Battle;
import jp.or.cute.sangokushi.R;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.text.format.Time;

public class TweetItem {
	private Context mContext;
	private TwitterJSON mJson;

	private JSONObject mStatus;
	private JSONObject mUser;
	private String mPlayerName;
	
	private String mTweet;
	private String mHashTag;
	
	public TweetItem(Context context, TwitterJSON json, JSONObject status) throws JSONException{
		mContext = context;
		mJson = json;
		mStatus = status;
		if(status.has("user")){
			mUser = status.getJSONObject("user");
		}else if(status.has("from_user")){
			mUser = new JSONObject();
			mUser.putOpt("name", status.get("from_user"));
		}
		mTweet = "";
		 
		if(mContext instanceof Battle){
			mHashTag = ((Battle)mContext).getHashTag();
		}
	}
	public String getCreatedAt() {
		@SuppressWarnings("unused")
		Time ret1 = new Time();
		String created_at = mStatus.optString("created_at", getString(R.string.bad_value));
		if(created_at != getString(R.string.bad_value)){
			Date date = new Date(Date.parse(mStatus.optString("created_at")));
			SimpleDateFormat stringFormat = new SimpleDateFormat("yyyy/MM/dd h:mm");
			created_at = stringFormat.format(date);
		}
		
		return created_at;
	}

	/*
	 * 「つぶやき」本文を取得
	 * ゲーム登録ユーザー名は[***]として文頭に書き込まれている前提<送信時に自動で付与
	 * ハッシュタグは削除<文末にハッシュタグ。送信時に自動で付与
	 */
	public String getText() {
		String text = mJson.getCurrentTweet(mStatus);
		Pattern pattern = Pattern.compile("^([[.*]])([.*])(#[.*])");
		Matcher matcher = pattern.matcher(text);
        if(matcher.find()) {
        	mPlayerName = matcher.group(1);
        	mTweet = matcher.group(2);
        }else{
        	mPlayerName = getUserName();
        	mTweet = text;
        }
        mTweet = mTweet.replace(mHashTag, "");
		return mTweet;
	}

	public String getGameUserName(){
		if(mPlayerName == null || mPlayerName.length() == 0){
			getText();
		}
		return mPlayerName;
	}
	public String getTweet(){
		if(mTweet == null || mTweet.length() == 0){
			getText();
		}
		return mTweet;
	}
	public String getUserName() {
		return mUser.optString("name", getString(R.string.bad_value));
	}

	private String getString(int resId){
		return mContext.getString(resId);
	}

	/*
	 * 一行分として整形
	 */
	public String getLine(){
		String text = getText();
		String line = mPlayerName + ">>" + mTweet;
		
		return line;
	}
}
