package jp.or.cute.sangokushi.twitter;

import java.io.IOException;
import java.util.LinkedList;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.commonshttp.CommonsHttpOAuthConsumer;
import oauth.signpost.exception.OAuthCommunicationException;
import oauth.signpost.exception.OAuthExpectationFailedException;
import oauth.signpost.exception.OAuthMessageSignerException;
import android.content.Context;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Handler;

/**
 * TweitterAPIの操作
 * @author iST
 * @version 0.1
 * @since 2010/03/29
 */
public class TwitterOperator {
	//設定情報key
	public static final String PREFS = "OpenSangokushiPrefsTwitterFile";
	public static final String USER_TWITTER_NAME = "twitter_name";
	public static final String USER_TWITTER_ID = "twitter_id";
	public static final String USER_TOKEN = "user_token";
	public static final String USER_SECRET = "user_secret";
	public static final String REQUEST_TOKEN = "request_token";
	public static final String REQUEST_SECRET = "request_secret";

	//Twitterへ登録したKEY
	public static final String TWITTER_CONSUMER_KEY = "ehnSS1WfLByqyp1QjS3xhA";
	public static final String TWITTER_CONSUMER_SECRET = "BmAmAu5Pl0ZclcnJ6cweW3SptVL5gKwRWUqWwM9a4";
	
	public static final Uri CALLBACK_URI = Uri.parse("twitter-oauth://sangokushi");

	//TwitterAPIのアドレス
	public static final String TWITTER_REQUEST_TOKEN_URL = "http://twitter.com/oauth/request_token";
	public static final String TWITTER_ACCESS_TOKEN_URL = "http://twitter.com/oauth/access_token";
	public static final String TWITTER_AUTHORIZE_URL = "http://twitter.com/oauth/authorize";
	public static final String TWITTER_UPDATE_URL = "http://twitter.com/statuses/update.json";
	public static final String VERIFY_URL_STRING = "http://twitter.com/account/verify_credentials.json";
	public static final String PUBLIC_TIMELINE_URL_STRING = "http://twitter.com/statuses/public_timeline.json";
	public static final String USER_TIMELINE_URL_STRING = "http://twitter.com/statuses/user_timeline.json";
	public static final String HOME_TIMELINE_URL_STRING = "http://api.twitter.com/1/statuses/home_timeline.json";	
	public static final String SEARCH_TIMELINE_URL_STRING = "http://search.twitter.com/search.json";	
	public static final String FRIENDS_TIMELINE_URL_STRING = "http://api.twitter.com/1/statuses/friends_timeline.json";	
	public static final String STATUSES_URL_STRING = "http://twitter.com/statuses/update.json";	
	
	public static final String DEFAULT_HASHTAG = "#osan";
	
	//呼び出し元Activity
	private Context mContext;
	//設定情報
	private SharedPreferences mSettings;
	//OAuth
	private OAuthConsumer mConsumer;
	//Twitter認証トークン
	public String mToken;
	//Twitter秘密キー
	public String mSecret;
	
	//TwitterID
	public String getTwitterID(){
		if(mSettings != null && mSettings.contains(USER_TWITTER_ID)){
			return mSettings.getString(USER_TWITTER_ID, null);
		}
		return null;
	}
	//TwitterToken
	public String getTwitterToken(){
		if(mSettings != null && mSettings.contains(USER_TOKEN)){
			return mSettings.getString(USER_TOKEN, null);
		}
		return null;
	}
	//TwitterSecret
	public String getTwitterSecret(){
		if(mSettings != null && mSettings.contains(USER_SECRET)){
			return mSettings.getString(USER_SECRET, null);
		}
		return null;
	}
	
	public TwitterOperator(Context context){
		mContext = context;
		
        //認証情報取得
		mSettings = mContext.getSharedPreferences(TwitterOperator.PREFS, Context.MODE_PRIVATE);
		//OAuthコンシューマー
		mConsumer = new CommonsHttpOAuthConsumer(
				TwitterOperator.TWITTER_CONSUMER_KEY, 
				TwitterOperator.TWITTER_CONSUMER_SECRET);     
		
		setToken();
		
	}

	/*
	 * 設定情報にTOKENがあればOAuthコンシューマーに登録
	 */
	private void setToken(){
		// 保存済の認証情報の確認
		if(mSettings.contains(USER_TOKEN) && mSettings.contains(USER_SECRET)) {
			mToken = mSettings.getString(USER_TOKEN, null);
			mSecret = mSettings.getString(USER_SECRET, null);
			if(!(mToken == null || mSecret == null)) {
				mConsumer.setTokenWithSecret(mToken, mSecret);
			}
		}
	}
	
	/*
	 * Twitterへ別スレッドで資格情報を確認
	 */
	public void asyncGetCredential(Handler handler){
		TwitterCredentialRunnable runnable = new TwitterCredentialRunnable(handler, mConsumer);
		new Thread(runnable).start();
	}
	
//	/*
//	 * ハッシュタグを検索
//	 */
//	public void GetHashTagTimeline(String hashTag, TweetArrayAdapter taa, LinkedList<TweetItem> lists){
//		mAA = taa;
//		mChatTweetLists = lists;
//		HashTagSelector hs = new HashTagSelector(SEARCH_TIMELINE_URL_STRING, hashTag);
//		new GetHashTagTimelineTask().execute(hs);
//	}
	
}
