package jp.or.cute.sangokushi.view;

import java.util.LinkedList;

import jp.or.cute.sangokushi.Battle;
import jp.or.cute.sangokushi.R;
import jp.or.cute.sangokushi.twitter.TweetArrayAdapter;
import jp.or.cute.sangokushi.twitter.TweetItem;
import jp.or.cute.sangokushi.twitter.TwitterOperator;
import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class ChatView extends TextView implements OnClickListener{
	//TwitterAPI制御
	private TwitterOperator mOperator;
	//ハッシュタグ
	private String mChatTag;
	
	public String getChatTag() {
		return mChatTag;
	}

	private ListView mTweetList;

	public ListView getTweetList() {
		return mTweetList;
	}
	
	private EditText mTweetEditor;
	public EditText getTweetEditor(){
		return mTweetEditor;
	}
	private Button mSendButton;
	
	private ChatPopupWindow mPopupWindow;
	private Activity mActivity;
	
	public ChatView(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
	}

	public ChatView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		// TODO Auto-generated constructor stub
	}

	public ChatView(Context context, AttributeSet attrs) {
		super(context, attrs);
		// TODO Auto-generated constructor stub
	}

	public void init(Activity activity, String room_id, String country_id){
		mActivity = activity;
		mChatTag = "#osan" + room_id + country_id;
		
		mPopupWindow = createPopUpWindow();
		
		setOnClickListener(this);
//        final ListView tweetlist = (ListView) findViewById(R.id.TweetListView);
//        mArrayAdapter = new TweetArrayAdapter(mActivity, R.layout.list);
//        tweetlist.setAdapter(mArrayAdapter);
//        tweetlist.setSelection(0);

		mOperator = new TwitterOperator(mActivity);
		if(mOperator.getTwitterToken() == null){
			this.setText(R.string.twitter_notauth_message);
			return;
		}
		//Twitterメッセージ取得
		loadTweets(mChatTag);
	}
	
    /*
     * チャット用ポップアップビューの作成
     */
    private ChatPopupWindow createPopUpWindow() {      	
        LinearLayout tv = (LinearLayout) mActivity.getLayoutInflater().inflate(  
                R.layout.popup, null);  
        
        ChatPopupWindow popupWindow = new ChatPopupWindow(mActivity);  
        popupWindow.setWindowLayoutMode(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);  
        popupWindow.setContentView(tv);
        
		if(mTweetList == null){
			mTweetList = (ListView) popupWindow.getContentView().findViewById(R.id.TweetListView);
		}

		if(mTweetEditor == null){
			mTweetEditor = (EditText) popupWindow.getContentView().findViewById(R.id.EditText01);
		}
		
		if(mSendButton == null){
			mSendButton = (Button) popupWindow.getContentView().findViewById(R.id.Button01);
		}
		mSendButton.setOnClickListener(this);
		mTweetEditor.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				showInputMethod();
			}
		});
		mTweetEditor.setOnFocusChangeListener(new OnFocusChangeListener() {
			@Override
			public void onFocusChange(View v, boolean hasFocus) {
				if(hasFocus){
					showInputMethod();
				}
			}
		});
		mTweetEditor.setOnTouchListener(new OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				showInputMethod();
				return false;
			}
		});
		
        return popupWindow;  
    }      

	
	@Override
	public void onClick(View v) {
		if(v.equals(mSendButton)){
			//Tweet送信
			sendTweet(mChatTag);
		}else if(v.equals(this)){
	        if(mPopupWindow.isShowing()) {  
	            mPopupWindow.dismiss();  
	        } else {  
	        	if(mOperator == null){
	        		mOperator = new TwitterOperator(mActivity);
	        	}
	    		if(mOperator.getTwitterToken() == null){
	    			mOperator.asyncGetCredential(((Battle)mActivity).getTwitterAuthenticateHandler());
	    			return;
	    		}
	        	
	    		//Twitterメッセージ取得
	    		loadTweets(mChatTag);
	    		
	            //mPopUpText.setText("Click!");  
	            mPopupWindow.showAsDropDown(this,0,0);  
	            
	            mTweetEditor.setFocusable(true);
	        }
		}
	}
	
	public void loadTweets(String hashtag){
		((Battle)mActivity).loadTweets(hashtag);
	}
	
	public void sendTweet(String hashtag){
		((Battle)mActivity).sendTweet(hashtag);
	}
	Handler mTweetEditorHandler;
	private void showInputMethod(){
		mTweetEditorHandler = new Handler();
	    Message m = Message.obtain(mTweetEditorHandler, new Runnable() {
	        @Override
	        public void run() {
	          InputMethodManager manager = (InputMethodManager)mActivity.getSystemService(Activity.INPUT_METHOD_SERVICE);
	          manager.showSoftInput(mTweetEditor, InputMethodManager.SHOW_IMPLICIT);
	        }
	      });
	    mTweetEditorHandler.sendMessage(m);
		
	}
}
