package jp.or.cute.sangokushi.view;

import java.util.Random;

import jp.or.cute.sangokushi.R;
import jp.or.cute.sangokushi.SangokushiPreferences;
import jp.or.cute.sangokushi.Lobby.battle_Status;
import jp.or.cute.sangokushi.dummy.DummyMapData;
import jp.or.cute.sangokushi.httpclient.BattleCommand;
import jp.or.cute.sangokushi.httpclient.BattleResultCommand;
import jp.or.cute.sangokushi.httpclient.HttpClient;
import jp.or.cute.sangokushi.httpclient.HttpCommand;
import jp.or.cute.sangokushi.httpclient.LobbyInfoCommand;
import jp.or.cute.sangokushi.httpclient.RoomInfoCommand;
import jp.or.cute.sangokushi.model.Player;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.util.AttributeSet;
import android.util.Log;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.widget.TextView;

public class MapView extends View implements GestureDetector.OnGestureListener,
														GestureDetector.OnDoubleTapListener{
	private Paint mPaintBg;
	private Paint mPaint;
	private Paint mPaintStroke;
	private GestureDetector mGestureDetector;
	private Activity activity;
	private MapView me;
	private WholeMapView mWholeMap;
	 
	public static final int CHIP_W = 32;
	public static final int CHIP_H = 32;
	private static int SHOW_PRESS = 1;
	private static int LONG_PRESS = 2;
	private static int DOUBLE_TAP = 3;
	private static int DOUBLE_TAP_EVENT = 4;
	private static int SINGLE_TAP_CONFIRMED = 5;
	private static int SINGLE_TAP_EVENT = 6;

	private static int EVENT_CANCEL = -1;
	private static String b01002_prev = "";
	public static String mUserName = "";
	
	private float mScale = 1;
	
	/*
	 * マップデータ
		1=山
		2=林
		3=草地
		4=砂地
		5=川
		6=湖
		7=城or陣
		8=街道
	 */
	private int[][] map;
	private Bitmap[] mapchips = new Bitmap[8];
	
	private float mTouchX = -1;
	private float mTouchY = -1;
	
	private int mCenterX = 0;
	private int mCenterY = 0;

	private int mMoveX = 0;
	private int mMoveY = 0;
	private int mCurrentX = 0;
	private int mCurrentY = 0;
	private int mCurrentMapX = 0;
	private int mCurrentMapY = 0;
//	private boolean mFirstDraw = true;
	private boolean mPlayerMovingFlag = false;
	
	// 
	private int mEvent = EVENT_CANCEL; 
	//ゲームプレイヤー
	private Player mPlayer;
	private Player[] mPlayers;
	
	//
	private String mUserid;
	private String mRoomid;
	
	private BattleCommand battleCommand; // = new BattleCommand();
	
	//全体地図用ハンドラー
	private Handler mWholeMapViewHandler;
	private Message mWholeMapViewMessage;
	
	public MapView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		init(context);
	}

	public MapView(Context context, AttributeSet attrs) {
		super(context, attrs);
		init(context);
	}

	public MapView(Context context) {
		super(context);
		init(context);
	}

	private void init(Context context){
		me = this;
		//マップチップ
        Resources r=context.getResources();
		//1=山
        mapchips[0] = BitmapFactory.decodeResource(r,R.drawable.forest); 
        //2=林
        mapchips[1] = BitmapFactory.decodeResource(r,R.drawable.tree); 
        //3=草地
        mapchips[2] = BitmapFactory.decodeResource(r,R.drawable.grass); 
        //4=砂地
        mapchips[3] = BitmapFactory.decodeResource(r,R.drawable.desert); 
        //5=川
        mapchips[4] = BitmapFactory.decodeResource(r,R.drawable.water); 
        //6=湖
        mapchips[5] = BitmapFactory.decodeResource(r,R.drawable.water); 
        //7=城or陣
        mapchips[6] = BitmapFactory.decodeResource(r,R.drawable.castle); 
        //8=街道
        mapchips[7] = BitmapFactory.decodeResource(r,R.drawable.street); 
        
		//マップ
		map = DummyMapData.createDummyMap();
		
		mPaintBg = new Paint();
		mPaintBg.setColor(Color.BLACK);
		mPaint = new Paint();
		mPaint.setStyle(Style.FILL);
		mPaintStroke = new Paint();
		mPaintStroke.setStyle(Style.STROKE);
		mPaintStroke.setColor(Color.BLACK);
		mPaintStroke.setStrokeWidth(0);
		
		this.setClickable(true);
		
		//フォーカス
		setFocusable(true);
		setFocusableInTouchMode(true);
		
//		mHolder = getHolder();
//		mHolder.addCallback(this);
//		mHolder.setFixedSize(getWidth(), getHeight());	
		
		mCenterX = getWidth() / 2;
		mCenterY = getHeight() / 2;
		mTouchX = mCenterX; 
		mTouchY = mCenterY; 
		
		//this.battleCommand = new BattleCommand(mUserid,mRoomid);
		this.mGestureDetector = new GestureDetector(context, this);
	}
	
	public void setUserAndRoom(String user,String room)
	{
		//this.battleCommand.setUserAndRoom(user,room);
		mUserid = user;
		mRoomid = room;
		Log.d("MapView","UserID="+mUserid+"|mRoomid="+mRoomid);
	}

	/*
	 * ゲームプレイヤーをセット
	 */
	public void setPlayer(Player player){
		mPlayer = player;
	}

	/*
	 * ゲームプレイヤーをセット
	 */
	public void setPlayers(Player[] players){
		mPlayers = players;
	}
/*
	public String getLobbyPlayers()
	{
		return battleCommand.httpPost("data=B01002");
	}
*/	
	public void setContent(Activity act)
	{
		this.activity = act;
	}
	/*
	 * 全体地図をセット
	 */
	public void setWholeMapViewHandler(Handler handler){
		mWholeMapViewHandler = handler;
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		//Log.d("MapView","onDraw");
		//Log.d("MapView","mTouchX="+Float.toString(mTouchX)+"|mTouchY="+Float.toString(mTouchY));
		drawMapBitmap(canvas, mMoveX, mMoveY);
    	mTouchX = -1;
    	mTouchY = -1;
	}

	private void drawMapBitmap(Canvas canvas, int moveX, int moveY){
		int col = 15;
		int row = 15;
		//Log.d("MapView","drawMapBitmap");
		//Log.d("drawMapBitmap","mCurrentMapX="+Integer.toString(mCurrentMapX)+"|mCurrentMapY="+Integer.toString(mCurrentMapY));
		int m = 1;
		int x = 0;
		int y = 0;
		int currentMapX = mCurrentMapX;
		int currentMapY = mCurrentMapY;	
		if(mScale == 0.0f){
			mScale = (float)getWidth() / 480f;			
		}
		
		if (mTouchX >= 0) {
			mCurrentMapX = currentMapX + (int) Math.round(mTouchX / (CHIP_W * mScale)) - col/2;
			mCurrentMapY = currentMapY + (int) Math.round(mTouchY / (CHIP_H * mScale)) - row/2;
		}
		if(mCurrentMapX < 0){
			mCurrentMapX = 0;
		}else if(mCurrentMapX > (map.length-col)){
			mCurrentMapX = (map.length-col);
		}
		if(mCurrentMapY < 0){
			mCurrentMapY = 0;
		}else if(mCurrentMapY > (map.length-row)){
			mCurrentMapY = (map.length-row);
		}
		
		canvas.drawRect(0, 0, getWidth(), getHeight(), mPaintBg);

		for(int i = mCurrentMapX; i < mCurrentMapX+col; i++){
			for(int j = mCurrentMapY; j < mCurrentMapY+row; j++){
				x = (int) ((i-mCurrentMapX) * CHIP_W * mScale);
				y = (int) ((j-mCurrentMapY) * CHIP_H * mScale);
				m = map[i][j]-1;
				if(mScale != 1.0f){
					canvas.drawBitmap(
							Bitmap.createBitmap(mapchips[m], 0, 0, (int)(CHIP_W*mScale), (int)(CHIP_H*mScale)),
							x, y, mPaint);
					canvas.drawRect(x, y, x+(int)(CHIP_W*mScale), y+(int)(CHIP_H*mScale), mPaintStroke);
				}else{
					canvas.drawBitmap(mapchips[m], x, y, mPaint);
					canvas.drawRect(x, y, x+CHIP_W, y+CHIP_H, mPaintStroke);
				}
			}
		}
		if (mPlayers != null) {
			for (int i=0;i<mPlayers.length;i++) {
				mPlayers[i].draw(canvas, mScale, mCurrentMapX ,mCurrentMapY);
			}
		}
		
		if(mPlayer != null){
			mPlayer.draw(canvas, mScale, mCurrentMapX ,mCurrentMapY);
			if (mPlayerMovingFlag) {
				mPlayer.drawMovingArea(canvas);
			}
		}
		
		if(mWholeMapViewHandler != null){
			//全体図へ反映
			mWholeMapViewMessage = new Message();
			int[] params = {mCurrentMapX,mCurrentMapY};
			mWholeMapViewMessage.obj = params;
			mWholeMapViewHandler.sendMessage(mWholeMapViewMessage);
		}
		
		mPaintStroke.setTextSize(16);
		canvas.drawText(String.valueOf(mCurrentX)+","+String.valueOf(mCurrentY), 15, 15, mPaintStroke);
		mPaintStroke.setTextSize(16);
		canvas.drawText(String.valueOf(mCurrentMapX)+","+String.valueOf(mCurrentMapY), 15, 30, mPaintStroke);
		
	}

	
	@Override
	public boolean onTouchEvent(MotionEvent event) {
        // Activityのタッチイベント中でGestureDetectorのイベントを呼び出す
        // 長押しやダブルタップ等はGestureDetector内で判定されて、
        // GestureDetectorに登録したリスナー(このクラス)に処理が振り分けられる
        // if文で戻り値を判定することで、GestureDetectorで処理した後、
        // 通常のonTouchEventをそのまま継続するかどうかを選択できる
        if(mGestureDetector.onTouchEvent(event)) return true;

        int touchAction = event.getAction();
//        Log.d("Touch Event","mTouchX="+Float.toString(mTouchX)+"|mTouchY="+Float.toString(mTouchY)+
//        	  "|Action="+Integer.toString(touchAction)+"|mEvent="+Integer.toString(mEvent));
		if(touchAction == MotionEvent.ACTION_DOWN){
			//Log.d("Touch Event","Down");
		}else if(touchAction == MotionEvent.ACTION_MOVE){
		}else if(touchAction == MotionEvent.ACTION_UP || 
				touchAction == MotionEvent.ACTION_CANCEL){
			mEvent = EVENT_CANCEL;
			//Log.d("Touch Event","Cancel");
		}
		return super.onTouchEvent(event);
	}

	@Override
	public boolean onDown(MotionEvent arg0) {
        Log.d("Touch Event","onDown");
		return false;
	}

	@Override
	public boolean onFling(MotionEvent arg0, MotionEvent arg1, float arg2, float arg3) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onFling");
		return false;
	}

	@Override
	public void onLongPress(MotionEvent arg0) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onLongPress");
		mTouchX = -1;
		mTouchY = -1;
		areaStatus(arg0.getX(), arg0.getY());
		mEvent = LONG_PRESS;
		this.invalidate();
	}

	@Override
	public boolean onScroll(MotionEvent arg0, MotionEvent arg1, float arg2,	float arg3) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void onShowPress(MotionEvent e) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onShowPress");
		mEvent = SHOW_PRESS;
/*		mTouchX = e.getX();
		mTouchY = e.getY();
		this.invalidate();
		Log.d("Touch Event","mTouchX="+Float.toString(mTouchX)+"|mTouchY="+Float.toString(mTouchY));
		mPlayerMovingFlag = false;
*/	}

	@Override
	public boolean onSingleTapUp(MotionEvent e) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onSingleTapUp");
		//mPlayerMovingFlag = false;
		return false;
	}

	@Override
	public boolean onDoubleTap(MotionEvent arg0) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onDoubleTap");
        mEvent = DOUBLE_TAP;
		return false;
	}

	@Override
	public boolean onDoubleTapEvent(MotionEvent arg0) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onDoubleTapEvent");
        Log.d("Touch Event","X="+Float.toString(arg0.getX())+"|Y="+Float.toString(arg0.getY()));
        mEvent = DOUBLE_TAP_EVENT;
		return false;
	}

	@Override
	public boolean onSingleTapConfirmed(MotionEvent arg0) {
		// TODO Auto-generated method stub
        Log.d("Touch Event","onSingleTapConfirmed");
		Log.d("Touch Event","mTouchX="+Float.toString(mTouchX)+"|mTouchY="+Float.toString(mTouchY));
        if (mPlayerMovingFlag) {
        	Float x = arg0.getX();
        	Float y = arg0.getY();
        	int cellX = (int)(x / MapView.CHIP_W) + mCurrentMapX;
        	int cellY = (int)(y / MapView.CHIP_H) + mCurrentMapY;
        	//Log.d("Move", "move=("+Float.toString(x)+","+Float.toString(y)+")");
        	//Log.d("Move", "move=("+Integer.toString(cellX)+","+Integer.toString(cellY)+")");
//        	battleCommand.MoveCell(cellX, cellY);

    		SangokushiPreferences pref = new SangokushiPreferences(activity);
    		BattleCommand command = new BattleCommand(HttpCommand.POST, pref.getSessionID());
    		command.setUserAndRoom(mUserid, mRoomid);
    		command.MoveCell(cellX,cellY);
    		//Log.d("MapView","mUserid="+mUserid+"|mRoomid="+mRoomid);
    		HttpClient httpclient = HttpClient.getInstance();
    		httpclient.setHttpCommand(command);
    		String result = (String) httpclient.execute();
        	//Log.d("player move","result=\""+result+"\"");
        	this.invalidate();
        	mPlayerMovingFlag = false;
        } else {
        	mEvent = SINGLE_TAP_EVENT;
        	mTouchX = arg0.getX();
        	mTouchY = arg0.getY();
    		boolean ret = areaStatus(arg0.getX(), arg0.getY());
    		if (ret) {
            	Float x = arg0.getX();
            	Float y = arg0.getY();
            	int cellX = (int)(x / MapView.CHIP_W) + mCurrentMapX;
            	int cellY = (int)(y / MapView.CHIP_H) + mCurrentMapY;
            	Log.d("Move", "move=("+Float.toString(x)+","+Float.toString(y)+")");
            	Log.d("Move", "move=("+Integer.toString(cellX)+","+Integer.toString(cellY)+")");
//            	battleCommand.MoveCell(cellX, cellY);

        		SangokushiPreferences pref = new SangokushiPreferences(activity);
        		BattleCommand command = new BattleCommand(HttpCommand.POST, pref.getSessionID());
        		command.setUserAndRoom(mUserid, mRoomid);
        		command.BattlePlayer(cellX,cellY);
        		//Log.d("MapView","mUserid="+mUserid+"|mRoomid="+mRoomid);
        		HttpClient httpclient = HttpClient.getInstance();
        		httpclient.setHttpCommand(command);
        		String result = (String) httpclient.execute();
            	//Log.d("player move","result=\""+result+"\"");
    			
    		}
        	this.invalidate();
        	mPlayerMovingFlag = false;
        }
        //mEvent = SINGLE_TAP_CONFIRMED;
		return false;
	}

	/*
	 * 指定座標上にの状態を判定し必要な処理を行う
	 */
	private boolean areaStatus(float x, float y){
		boolean ret = false;
		//プレイヤー
		if(mPlayer.hitTest(x, y)){
			//移動可能範囲表示
			mPlayerMovingFlag = true;
		}
		else {
			for (int i=0;i<mPlayers.length;i++) {
				if (mPlayers[i].hitTest(x,y)) {
					if (mPlayers[i].getMySelf()) {
						mPlayerMovingFlag = true;
					} else {
						Log.d("areaStatus","Name="+mPlayers[i].getName()+"|Country="+mPlayers[i].getCountry());
						//String text = mPlayers[i].getName() + " 兵力:" + Integer.toString(mPlayers[i].getPower());
						AlertDialog.Builder dlg;
						dlg = new AlertDialog.Builder(this.getContext());
						dlg.setTitle(mPlayers[i].getName());
						String msg = "所属:" + mPlayers[i].getCountryName();
						msg += "\n階級:" + mPlayers[i].getCommanderClass(); 
						msg += "\n兵力:" + Integer.toString(mPlayers[i].getPower());
						dlg.setMessage(msg);
						DialogInterface.OnClickListener listner = new DialogInterface.OnClickListener(){
							@Override
							public void onClick(DialogInterface dialog, int which) {
								//Log.d("Button",Integer.toString(which));
								activity.setResult(Activity.RESULT_OK);
							}
						};

						dlg.setNegativeButton("OK", listner);
						dlg.show();
						if (mPlayer.getCountryID() != mPlayers[i].getCountryID()) {
							int en_x = mPlayers[i].mMapX;
							int en_y = mPlayers[i].mMapY;
							int me_x = mPlayer.mMapX;
							int me_y = mPlayer.mMapY;
							if (((me_x-1) <= en_x && en_x <= (me_x+1)) &&
								((me_y-1) <= en_y && en_y <= (me_y+1))) {
								ret = true;
							}
						}
					}
					break;
				}
			}
		}
		return ret;
	}
	
	public void setWholeMapView(WholeMapView mWholeMapView)
	{
		mWholeMap = mWholeMapView;
	}
	
	private boolean noWriteFlag = false;

	public Player[] makePlayers(String msg) {
		noWriteFlag = false;
		String[] pInfo = msg.split(">>");
		//Log.d("makePlayers","size="+Integer.toString(pInfo.length));
		Player[] players = new Player[pInfo.length-1];
		//Log.d("makePlayers","players size="+Integer.toString(players.length));
		for (int i=1,j=0;i<pInfo.length;i++,j++) {
			if (i==1) {
				// 戦闘が@の場合は
				if (pInfo[i].startsWith("@")) {
					noWriteFlag = true;
					break;
				}
			}
			int top = 0;
			String[] pValue = pInfo[i].split(",");
			//Log.d("makePlayers","["+pValue[0]+"]["+pValue[1]+"]["+pValue[2]+"]["+pValue[3]+"]["+pValue[4]+"]");
			//Log.d("makePlayers","Call setInfo i="+Integer.toString(i)+"|j="+Integer.toString(j));
			players[j] = new Player(this.activity,pValue[top+1]);
			int cell = Integer.parseInt(pValue[top+3]);
			int power = Integer.parseInt(pValue[top+4]);
			players[j].setInfo(power, 0, pValue[top+0], Integer.parseInt(pValue[top+2])-1, cell);
			if (players[j].getName().equals(mUserName)) {
				players[j].setMySelf();
				setPlayer(players[j]);
				//				player = players[i];
			}
		}
		return players;
	}
	
	private boolean reWrite = false;
	public Player[] getPlayerInfo()
	{
		reWrite = false;
		SangokushiPreferences pref = new SangokushiPreferences(activity);
		BattleResultCommand command = new BattleResultCommand(HttpCommand.POST, pref.getSessionID(),this.mRoomid);
		HttpClient httpclient = HttpClient.getInstance();
		httpclient.setHttpCommand(command);
		String playerInfo = (String) httpclient.execute();
		if (playerInfo != this.b01002_prev) {
			reWrite = true;
		}
		this.b01002_prev = playerInfo;
		Log.d("Battle","playerInfo="+playerInfo);
//		String playerInfo = map.getLobbyPlayers();
		Player[] players = makePlayers(playerInfo);
		return players;
	}
	
	private int mCurrentTurn=0;
	private int mMaxTurn = 60;
	public void getRoomInfo()
	{
		SangokushiPreferences pref = new SangokushiPreferences(activity);
		RoomInfoCommand command = new RoomInfoCommand(HttpCommand.POST, pref.getSessionID(), this.mRoomid);
		HttpClient httpclient = HttpClient.getInstance();
		httpclient.setHttpCommand(command);
		
		String result = (String) httpclient.execute();
		Log.d("getRoomInfo","rsult="+result);
    	String[] param = result.split(">>");
    	String[] value = param[1].split(",");
    	if (mCurrentTurn != Integer.valueOf(value[1])) {
    		int maxTurn = Integer.valueOf(value[0]);
    		int currentTurn = Integer.valueOf(value[1]);
    		if (currentTurn != mCurrentTurn) {
    			mCurrentTurn = currentTurn;
    			int diffTurn = mMaxTurn - mCurrentTurn;
/*    			TextView currentTurnView = (TextView) findViewById(R.id.TextView03);
    			currentTurnView.setText(Integer.toString(mCurrentTurn)+"日目");
    			TextView diffTurnView = (TextView) findViewById(R.id.TextView01);
    			currentTurnView.setText("残り"+Integer.toString(diffTurn)+"日");
*/    		}
    	}
	}
	
	private static final int INVALIDATE = 1;
	private Player[] players;

    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
        	Log.d("handleMessage","mCurrentTurn="+Integer.toString(mCurrentTurn)+"|mMaxTurn="+Integer.toString(mMaxTurn));
    		if (mCurrentTurn != mMaxTurn) {
    			// 表示 
    	    	TextView currentTurnView = (TextView) activity.findViewById(R.id.TextView03);
    	    	currentTurnView.setText(Integer.toString(mCurrentTurn)+"日目");
    	    	int diffTurn = mMaxTurn - mCurrentTurn;
    	    	TextView diffTurnView = (TextView) activity.findViewById(R.id.TextView01);
    	    	diffTurnView.setText("残り"+Integer.toString(diffTurn)+"日");
                if (mAnimate && msg.what == INVALIDATE) {
           		    players = getPlayerInfo();
        		    getRoomInfo();
				    me.invalidate();
        		    if (mCurrentTurn == mMaxTurn) {
				    	AlertDialog.Builder dlg;
					    dlg = new AlertDialog.Builder(me.getContext());
					    dlg.setTitle("戦闘終了");
					    String mg = "この戦いは終了しました";
					    dlg.setMessage(mg);
					    DialogInterface.OnClickListener listner = new DialogInterface.OnClickListener(){
						    @Override
						    public void onClick(DialogInterface dialog, int which) {
							    //Log.d("Button",Integer.toString(which));
							    activity.setResult(Activity.RESULT_OK);
						    }
					    };

					    dlg.setNegativeButton("OK", listner);
					    dlg.show();
        		    }
        		    if (!noWriteFlag && reWrite) {
        			    mWholeMap.setPlayers(players);
        			    setPlayers(players);
        			    me.invalidate();
        		    }
                    msg = obtainMessage(INVALIDATE);
                    long current = SystemClock.uptimeMillis();
                    if (mNextTime < current) {
                        // 100ms周期でタイマーイベントが発生
                        mNextTime = current + 10000;
                    }
                    sendMessageAtTime(msg, mNextTime);
                    // 100ms周期でタイマーイベントが発生
                    mNextTime += 10000;
                }
    		}
        }
    };
    /**
     * WindowにAttachされた時の処理
     */
    protected void onAttachedToWindow(){
        mAnimate = true;
        Message msg = mHandler.obtainMessage(INVALIDATE);
        mNextTime = SystemClock.uptimeMillis();
        mHandler.sendMessageAtTime(msg, mNextTime);
        super.onAttachedToWindow();
    }
   
    /**
     * WindowからDetachされた時の処理
     */
    protected void onDetachedFromWindow() {
         mAnimate = false;
         super.onDetachedFromWindow();
    }
    private boolean         mAnimate;
    private long            mNextTime;
}
